#ifndef PILOT_H
#define PILOT_H

typedef struct Gpio {
  unsigned pin;
  enum { ACTIVE_LOW, ACTIVE_HIGH } polarity;
} Gpio;

typedef struct HwOutput {
  const char *name;
  enum { OUT_PWR, OUT_RST, OUT_BOOT, OUT_LED } type;
  Gpio gpio;
} HwOutput;

typedef struct HwInput {
  const char *name;
  Gpio  gpio;
  const char *pressed;
  const char *longPressed;
} HwInput;

typedef struct PilotHw {
  const char *version;
  const unsigned pullups;
  const HwInput *ins;   unsigned char insNb;
  const HwOutput *outs; unsigned char outsNb;
} PilotHw;

extern PilotHw pilots[];
extern const unsigned char pilotsNb;
extern unsigned char pilotsIdx;

extern void setHardware(const char *hwRev);

#endif /* PILOT_H */
