#ifndef BUFFER_H
#define BUFFER_H

#include <pthread.h>

#define MAX (80*25*10)

/** Each entry in Buffer is 9 bytes (1x hdr + 8x data):
 * HDR = aaa.tt.sss
 * aaa = Port (111 is all)
 * tt = type: 00:read, 01:write, 02:info, 03:error
 * sss: size-1 (1-8 data bytes)
 */
class Buffer {
 protected:
  char buf[MAX][9];

  int wr;
  int rd;
  pthread_mutex_t mutex;

 public:
  Buffer();
 ~Buffer(void);

  void put(const char* str);
  bool get(int session, char* data);
  void dump(void);
};
#endif /*BUFFER_H*/
