<?php

class SocketC {
  private $socket;
  private $err = FALSE;

  function __construct() {
    $this->socket = socket_create(AF_UNIX, SOCK_STREAM, 0);
    if ($this->socket === FALSE) {
      $this->err = "socket_create: ". socket_strerror(socket_last_error());
      return;
    }
    if (socket_connect($this->socket, "/usr/local/tmp/tobe-pilotd.sock") === FALSE) {
      $this->err = "socket_connect: ". socket_strerror(socket_last_error());
      return;
    }
  }

  function __destruct() {
    if ($this->err !== FALSE) socket_close($this->socket);
  }

  function write($msg) {
    if ($this->err !== FALSE) return 0;
    return socket_write($this->socket, $msg);
  }

  function read() {
    if ($this->err !== FALSE) return "";
    return socket_read($this->socket, 1024);
  }

  function error() {
    return $this->err;
  }
}

header("Content-Type: text/plain");

if (!empty($_GET['get'])) {
  $sock = new SocketC();
  if ($sock->error() !== FALSE) {
    echo "<span class='red'>Error: " . $sock->error() . "</span>" . PHP_EOL;
    die();
  }
  //$sock->write("read:"+$_GET['get']);
  $sock->write("read");
  echo $sock->read(); // in while loop
} else if (!empty($_GET['send'])) {
  $sock = new SocketC();
  if ($sock->error() !== FALSE) {
    echo "<span class='red'>Error[" . $_GET['send'] . "]: " . $sock->error() . "</span>" . PHP_EOL;
    die();
  }
  $sock->write($_GET['send'] );
  echo "OK";

} else {
  echo "What's up?".PHP_EOL;
  print_r($_GET);
}
?>
